# [Orange Boosted with Bootstrap](http://orange-opensource.github.io/Orange-Boosted-Bootstrap)

Orange Boosted is a framework library accessible, ergonomic and Orange branded based on Bootstrap.
Bootstrap is a sleek, intuitive, and powerful front-end framework for faster and easier web development, created by [Mark Otto](https://twitter.com/mdo) and [Jacob Thornton](https://twitter.com/fat), and maintained by the [core team](https://github.com/orgs/twbs/people) with the massive support and involvement of the community.

All the core components of Bootstrap accessible and Orange branded.
And also specific components only available in Boosted.
[Main navigation with or without Mega menu](http://orange-opensource.github.io/Orange-Boosted-Bootstrap/components/#megamenu)
[Local navigation](http://orange-opensource.github.io/Orange-Boosted-Bootstrap/components/#local1)
[Stepbar](http://orange-opensource.github.io/Orange-Boosted-Bootstrap/components/#stepbar)
[Orange link pagination](http://orange-opensource.github.io/Orange-Boosted-Bootstrap/components/#orange-pagination)
[Accordions with indicator](http://orange-opensource.github.io/Orange-Boosted-Bootstrap/javascript/#collapse-example-accordion)
[Orange pointed tabs](http://orange-opensource.github.io/Orange-Boosted-Bootstrap/components/#o-nav-tabs)
[Complex table](http://orange-opensource.github.io/Orange-Boosted-Bootstrap/javascript/#complextable)
[Responsive table, display as cards onto tablets and mobile](http://orange-opensource.github.io/Orange-Boosted-Bootstrap/css/#tables-responsive)
[Popin (modal window)](http://orange-opensource.github.io/Orange-Boosted-Bootstrap/javascript/#modals)
[Orange branded checkboxes and radios](http://orange-opensource.github.io/Orange-Boosted-Bootstrap/css/#orange-branded-checkboxes-and-radios)
[Forms with new html5 elements and a Javascript validation](http://orange-opensource.github.io/Orange-Boosted-Bootstrap/examples/example_form/)
[Footer](http://orange-opensource.github.io/Orange-Boosted-Bootstrap/components/#footer)
        
                
To get started, check out <http://orange-opensource.github.io/Orange-Boosted-Bootstrap>!

## Table of contents

- [Quick start](#quick-start)
- [Bugs and feature requests](#bugs-and-feature-requests)
- [Copyright and license](#copyright-and-license)

## Quick start

Several quick start options are available:

- [Download the latest release](https://github.com/Orange-OpenSource/Orange-Boosted-Bootstrap/blob/v3.2.1/boosted-v3.2.1.zip).
- Clone the repo: `git clone https://github.com/Orange-OpenSource/Orange-Boosted-Bootstrap.git`.
- Install with [Bower](http://bower.io): `bower install boosted`.
- Install with [npm](https://www.npmjs.com): `npm install boosted`.

Read the [Getting started page](http://orange-opensource.github.io/Orange-Boosted-Bootstrap/getting-started/) for information on the framework contents, templates and examples, and more.

### What's included

Within the download you'll find the following directories and files, logically grouping common assets and providing both compiled and minified variations. You'll see something like this:

```
boosted/
├── css/
│   ├── boosted.css
│   ├── boosted.css.map
│   ├── boosted.min.css
│   ├── boostedIE8.css
│   ├── boostedIE8.css.map
│   ├── boostedIE8.min.css
│   ├── bootstrap-orange.css
│   ├── bootstrap-orange.css.map
│   ├── bootstrap-orange.min.css
│   ├── bootstrap-orangeIE8.css
│   ├── bootstrap-orangeIE8.css.map
│   ├── bootstrap-orangeIE8.min.css
│   ├── bootstrap-orange-theme.css
│   ├── bootstrap-orange-theme.css.map
│   ├── bootstrap-orange-theme.min.css
│   ├── bootstrap-orange-themeIE8.css
│   ├── bootstrap-orange-themeIE8.css.map
│   └── bootstrap-orange-themeIE8.min.css
├── js/
│   ├── boosted.js
│   └── boosted.min.js
├── images/
│   ├── ...
│   └── ...
└── fonts/
    ├── glyphicons-halflings-regular.eot
    ├── glyphicons-halflings-regular.svg
    ├── glyphicons-halflings-regular.ttf
    ├── glyphicons-halflings-regular.woff
    ├── glyphicons-halflings-regular.woff2
    ├── HelvNeue75_W1G.eot
    ├── HelvNeue75_W1G.svg
    ├── HelvNeue75_W1G.ttf
    ├── HelvNeue75_W1G.woff
    ├── HelvNeue75_W1G.woff2
    ├── HelvNeue55_W1G.eot
    ├── HelvNeue55_W1G.svg
    ├── HelvNeue55_W1G.ttf
    ├── HelvNeue55_W1G.woff
    ├── HelvNeue55_W1G.woff2   
    ├── icon-orange.eot
    ├── icon-orange.svg
    ├── icon-orange.ttf
    └── icon-orange.woff
```

We provide compiled CSS and JS (`*.*`), as well as compiled and minified CSS and JS (`*.min.*`). CSS [source maps](https://developer.chrome.com/devtools/docs/css-preprocessors) (`*.map`) are available for use with certain browsers' developer tools. Fonts from Glyphicons are included, as is the optional Bootstrap theme.
                             

## Bugs and feature requests

Have a bug or a feature request? Search for existing and closed issues. If your problem or idea is not addressed yet, [please open a new issue](Orange-OpenSource/Orange-Boosted-Bootstrap/issues/new).


## Copyright and license

Code and documentation copyright 2015 Orange SA. Code released under [the MIT license](https://github.com/Orange-OpenSource/Orange-Boosted-Bootstrap/blob/master/LICENSE). Docs released under [Creative Commons](https://github.com/Orange-OpenSource/Orange-Boosted-Bootstrap/blob/master/docs/LICENSE).
